<?php

include_once "config.php";
include_once "functions.php";

$now = date("Y-m-d H:i:s");
$sql = "SELECT chat_id, message_id FROM auto_delete_messages WHERE delete_time <= ?";
$stmt = $conn->prepare($sql);
$stmt->bind_param("s", $now);
$stmt->execute();
$result = $stmt->get_result();

while ($row = $result->fetch_assoc()) {
    deleteMessage($row['chat_id'], $row['message_id']);
    $delete_sql = "DELETE FROM auto_delete_messages WHERE message_id = ?";
    $delete_stmt = $conn->prepare($delete_sql);
    $delete_stmt->bind_param("i", $row['message_id']);
    $delete_stmt->execute();
}
