<?php include_once "config.php";
include_once "functions.php";

$botId = 7578456414;
$update = json_decode(file_get_contents('php://input'));

$‌BLACK_WORDS = [
    "خمینی",
    "نون",
    "خربزه",
    "هندونه"
];

$PERSIAN_NUMBER = [
    "یک" => 1,
    "دو" => 2,
    "سه" => 3,
    "چهار" => 4,
    "پنج" => 5,
    "شش" => 6,
    "هفت" => 7,
    "هشت" => 8,
    "نه" => 9,
    "ده" => 10,
    "صد" => 100,
    "هزار" => 1000,
];

$MAIN_MENU = [
    'inline_keyboard' => [
        [
            ['text' => "برترین رمزارز ها 🥇", 'callback_data' => "goto_toptokens"],
        ],
        [
            ['text' => "توکن های تون 💎", 'callback_data' => "goto_tontokens"],
            ['text' => "میم کوین ها 🚀", 'callback_data' => "goto_memetokens"],
        ],
        [
            ['text' => "راهنما 📄", 'callback_data' => "goto_helppage"],
            ['text' => "طلا و سکه 💰", 'callback_data' => "goto_goldprices"],
            ['text' => "داغ ترین ها 🔥", 'callback_data' => "goto_hottokens"],
        ],
        [
            ['text' => "افزودن ربات به گروه 📲", 'url' => "https://t.me/ArzDGXbot?startgroup=true"],
        ],
    ]
];

$TON_TOKENS = [
    'inline_keyboard' => [
        [
            ['text' => "💰 تون", 'callback_data' => "price_" . "TON" . "_" . 1],
            ['text' => "💰 ناتکوین", 'callback_data' => "price_" . "NOT" . "_" . 1],
        ],
        [
            ['text' => "💰 کتیزن", 'callback_data' => "price_" . "CATI" . "_" . 1],
            ['text' => "💰 میم هش", 'callback_data' => "price_" . "MEMHASH" . "_" . 1],
        ],
        [
            ['text' => "💰 تپ سواپ", 'callback_data' => "price_" . "TAPS" . "_" . 1],
            ['text' => "💰 ایکس ایمپایر", 'callback_data' => "price_" . "X" . "_" . 1],
        ],
        [
            ['text' => "💰 میجر", 'callback_data' => "price_" . "MAJOR" . "_" . 1],
            ['text' => "💰 همستر", 'callback_data' => "price_" . "HMSTR" . "_" . 1],
        ],
        [
            ['text' => "💰 تون استیشن", 'callback_data' => "price_" . "SOON" . "_" . 1],
            ['text' => "💰 ووف", 'callback_data' => "price_" . "WOOF" . "_" . 1],
        ],
        [
            ['text' => "💰 زوو", 'callback_data' => "price_" . "ZOO" . "_" . 1],
            ['text' => "💰 کتس", 'callback_data' => "price_" . "CATS" . "_" . 1],
        ],
        [['text' => "بازگشت 📤", 'callback_data' => "goto_mainmenu"]]
    ]
];

$MEME_TOKENS = [
    'inline_keyboard' => [
        [
            ['text' => "💰 دوج کوین", 'callback_data' => "price_" . "DOGE" . "_" . 1],
            ['text' => "💰 شیبا", 'callback_data' => "price_" . "SHIB" . "_" . 1],
        ],
        [
            ['text' => "💰 پپه", 'callback_data' => "price_" . "PEPE" . "_" . 1],
            ['text' => "💰 ترامپ", 'callback_data' => "price_" . "TRUMP" . "_" . 1],
        ],
        [
            ['text' => "💰 بونک", 'callback_data' => "price_" . "BONK" . "_" . 1],
            ['text' => "💰 فلوکی", 'callback_data' => "price_" . "FLOKI" . "_" . 1],
        ],
        [
            ['text' => "💰 ویف", 'callback_data' => "price_" . "WIF" . "_" . 1],
            ['text' => "💰 زن ترامپ", 'callback_data' => "price_" . "MELANIA" . "_" . 1],
        ],
        [
            ['text' => "💰 پنگو", 'callback_data' => "price_" . "PENGU" . "_" . 1],
            ['text' => "💰 نات کوین", 'callback_data' => "price_" . "NOT" . "_" . 1],
        ],
        [
            ['text' => "💰 بی بی دوج", 'callback_data' => "price_" . "BabyDoge" . "_" . 1],
            ['text' => "💰 پاپ کت", 'callback_data' => "price_" . "POPCAT" . "_" . 1],
        ],
        [['text' => "بازگشت 📤", 'callback_data' => "goto_mainmenu"]]
    ]
];

$TOP_TOKENS = [
    'inline_keyboard' => [
        [
            ['text' => "💰 بیت کوین", 'callback_data' => "price_" . "BTC" . "_" . 1],
            ['text' => "💰 اتریوم", 'callback_data' => "price_" . "ETH" . "_" . 1],
        ],
        [
            ['text' => "💰 ریپل", 'callback_data' => "price_" . "XRP" . "_" . 1],
            ['text' => "💰 بایننس کوین", 'callback_data' => "price_" . "BNB" . "_" . 1],
        ],
        [
            ['text' => "💰 سولانا", 'callback_data' => "price_" . "SOLANA" . "_" . 1],
            ['text' => "💰 کاردانو", 'callback_data' => "price_" . "ADA" . "_" . 1],
        ],
        [
            ['text' => "💰 دوج کوین", 'callback_data' => "price_" . "DOGE" . "_" . 1],
            ['text' => "💰 ترون", 'callback_data' => "price_" . "TRON" . "_" . 1],
        ],
        [
            ['text' => "💰 پای نتورک", 'callback_data' => "price_" . "PI" . "_" . 1],
            ['text' => "💰 سویی", 'callback_data' => "price_" . "SUI" . "_" . 1],
        ],
        [['text' => "بازگشت 📤", 'callback_data' => "goto_mainmenu"]]
    ]
];

$BACK_MENU = [
    'inline_keyboard' => [
        [['text' => "بازگشت 📤", 'callback_data' => "goto_mainmenu"]]
    ]
];


function getGoldPrice()
{
    $data = json_decode(file_get_contents("gold/data.json"), true)['data'];
    return $data['gold'];
}

function addSearch($searchTerm)
{

    // فایل JSON که داده‌ها در آن ذخیره می‌شود
    $jsonFile = 'search_data.json';

    // بررسی وجود فایل و خواندن محتویات آن
    if (file_exists($jsonFile)) {
        $jsonData = file_get_contents($jsonFile);
        $searchData = json_decode($jsonData, true);
    } else {
        $searchData = [];
    }

    // اگر کلمه از قبل وجود دارد، مقدار آن را افزایش می‌دهیم
    if (isset($searchData[$searchTerm])) {
        $searchData[$searchTerm]++;
    } else {
        $searchData[$searchTerm] = 1;
    }

    // ذخیره داده‌های به‌روزرسانی شده در فایل JSON
    file_put_contents($jsonFile, json_encode($searchData, JSON_PRETTY_PRINT));
}

function topSearch()
{

    // فایل جیسونی که داده‌ها در آن ذخیره می‌شود
    $jsonFile = 'search_data.json';

    // دریافت 10 کلمه پرجستجو
    $topSearches = [];
    if (file_exists($jsonFile)) {
        $jsonData = file_get_contents($jsonFile);
        $searchData = json_decode($jsonData, true);
        arsort($searchData); // مرتب‌سازی نزولی بر اساس تعداد جستجو
        $topSearches = array_slice($searchData, 0, 10, true);
    } else {
        $topSearches = [];
    }

    return $topSearches;
}

if (isset($update->message)) {
    $message = $update->message;
    if (isset($message->text)) {
        $text = $message->text;
    } else if (isset($message->caption)) {
        $text = $message->caption;
    }
    $entities = $message->entities ?? [];
    $caption_entities = $message->caption_entities ?? [];
    $entities = array_merge($entities, $caption_entities);
    $tc = $message->chat->type;
    $chat_id = $message->chat->id;
    $from_id = $message->from->id;
    $message_id = $message->message_id;

    //-------------------------
    // رویداد عضو شدن ربات در گروه (new_chat_members)
    //-------------------------
    if (isset($message->new_chat_members)) {

        $chat = $update->message->chat;

        foreach ($update->message->new_chat_members as $member) {
            if ($member->id == $botId) {
                // ربات به گروه اضافه شده است، ابتدا تعداد اعضای گروه را دریافت می‌کنیم
                $result  = bot("getChatMemberCount", ['chat_id' => $chat_id]);

                if ($result->ok) {
                    $memberCount = $result->result;

                    if ($memberCount < 100) {
                        // اگر تعداد اعضا کمتر از ۱۰۰ است، ربات از گروه خارج می‌شود
                        bot("sendMessage", ['chat_id' => $chat_id, 'text' => '🚨 گروه شما کمتر از ۱۰۰ عضو دارد']);
                        bot("leaveChat", ['chat_id' => $chat_id]);
                        die();
                    } else {
                        // گروه مناسب است؛ ذخیره اطلاعات گروه در دیتابیس (chat_id و join_date)
                        $join_date = date("Y-m-d H:i:s");
                        $sql = "INSERT INTO groups (chat_id, join_date) VALUES ('{$chat_id}', '{$join_date}')
                            ON DUPLICATE KEY UPDATE join_date = '{$join_date}'";
                        $conn->query($sql);
                        bot("sendMessage", ['chat_id' => $chat_id, 'text' => 'عضویت با موفقیت انجام شد']);
                        bot("sendMessage", ['chat_id' => $chat_id, 'text' => "نصب ربات با موفقیت انجام شد ✅\nاینجا می‌تونی قیمت ارزهای دیجیتال رو به‌صورت لحظه‌ای از معتبرترین صرافی‌ها و به شکل کاملاً رایگان دریافت کنی!\n\nبرای گرفتن قیمت، کافیه یکی از این فرمت‌ها رو بفرستی:\n🔹 کلمه قیمت + نماد ارز (بدون فاصله)\n🔹 کلمه قیمت + تعداد + نماد ارز\n\nمثال‌ها:\n• قیمت ۲۵ نات\n• قیمت ۴۰۰ TON\n• قیمت BTC\n• قیمت بیتکوین"]);
                        bot("sendMessage", ['chat_id' => $ADMIN, 'text' => 'ربات عضو یک گروه جدید شد']);
                        die();
                    }
                }
            }
        }
    }

    //-------------------------
    // رویداد حذف شدن ربات از گروه (left_chat_member یا my_chat_member)
    //-------------------------
    if (isset($message->left_chat_member)) {
        $leftMember =  $message->left_chat_member;
        if ($leftMember->id == $botId) {
            $sql = "DELETE FROM groups WHERE chat_id = '{$chat_id}'";
            $conn->query($sql);
        }
    }
} else if (isset($update->my_chat_member)) {

    $chat = $update->my_chat_member->chat;

    // لفت از چنل ها
    if ($chat->type == "channel" && $chat->id != -1002100426026 && $chat->id != -1002152751039) {
        bot("leaveChat", ["chat_id" => $chat->id]);
        die();
    }

    $newStatus = $update->my_chat_member->new_chat_member->status;
    $oldStatus = $update->my_chat_member->old_chat_member->status;

    if ($newStatus === "left" || $newStatus === "kicked" || $newStatus === "member" || $newStatus === "restricted") {
        $chat_id = $chat->id;
        $sql = "DELETE FROM groups WHERE chat_id = '{$chat_id}'";
        $conn->query($sql);
        bot("leaveChat", ['chat_id' => $chat_id]);
        die();
    }
} else if (isset($update->callback_query)) {
    $callback_query = $update->callback_query;
    $data = $callback_query->data;
    $tc = $callback_query->message->chat->type;
    $text = $callback_query->message->text;
    $chat_id = $callback_query->message->chat->id;
    $from_id = $callback_query->from->id;
    $message_id = $callback_query->message->message_id;
    $membercall = $callback_query->id;
} else {
    die();
}

// ثبت درخواست های کاربر
if (isset($tc) && $tc == "private") {

    addUserRequest($chat_id);

    // check join
    $notJoinedChannels = getNonJoinedChannels($from_id);
    if (!empty($notJoinedChannels)) {
        sendMessage([
            'chat_id' => $from_id,
            'text' => '💢 برای استفاده از ربات باید ابتدا در چنل های زیر عضو شوید و سپس روی دکمه "عضو شدم ✅" کلیک کنید',
            'reply_markup' =>  json_encode([
                'inline_keyboard' => [
                    [['text' => "کانال اصلی 🌐", 'url' => "https://t.me/qpcod"],],
                    [['text' => "کانال دوم 🌐", 'url' => "https://t.me/qpBots"],],
                    [['text' => "عضو شدم ✅", 'url' => "https://t.me/arzDGXbot?start=join"],],
                ]
            ])
        ]);
        die();
    }

    // check premium
    if (isset($message->from->is_premium) && $message->from->is_premium) {

        $boosts = bot("getUserChatBoosts", [
            'chat_id' => '@qpcod',
            'user_id' => $chat_id
        ]);

        if (isset($boosts->result->boosts) && count($boosts->result->boosts) < 2) {
            sendMessage([
                'chat_id' => $from_id,
                'text' => '💢 کاربر عزیز جهت حمایت از ما ابتدا از طریق دکمه زیر چنل رو بوست کنید (حداقل 2 تا)  سپس روی دکمه "بوست کردم ✅" کلیک کنید',
                'reply_markup' =>  json_encode([
                    'inline_keyboard' => [
                        [['text' => " بوست چنل 🚀", 'url' => "https://t.me/boost/qpcod"],],
                        [['text' => " بوست کردم✅", 'url' => "https://t.me/arzDGXbot?start=boost"],],
                    ]
                ])
            ]);
            die();
        }
    }
}

// ثبت درخواست گروه ها
if (isset($tc) && ($tc == "group" || $tc == "supergroup")) {
    addGroupRequest($chat_id);
}

if (isset($update->callback_query)) {

    if (strpos($data, "price_") === 0) {
        $query_parts = explode('_', $data);
        $token = $query_parts[1];
        $count = (float)$query_parts[2];

        $searchToken = searchWithSuggestions($token, $count);

        if (isset($searchToken['ok']) && $searchToken['ok']) {

            $searchText = "";
            $searchKeys = [
                'inline_keyboard' => []
            ];

            foreach ($searchToken['exchanges'] as $exchange => $data) {
                if ($data) {
                    $searchText .= "⚡️ طبق آخرین آپدیت صرافی {$exchange} :\n💸 ";
                    if ($count != 1) {
                        $searchText .=  $count . " " . $searchToken['symbol'] . " = " . $data['total_price'] . " " . $data['currency'] . "\n💸 ";
                    }
                    $searchText .= 1 . " " . $searchToken['symbol'] . " = " .  $data['last_price'] . " " . $data['currency'] . "\n\n";

                    if (isset($data['urls']) && $data['urls']) {
                        $keys = [];
                        foreach ($data['urls'] as $title => $url) {
                            $keys[] =  ['text' => $title, 'url' => $url];
                        }
                        $searchKeys['inline_keyboard'][] = $keys;
                    }
                }
            }

            $searchKeys['inline_keyboard'][] = [['text' => "بازگشت 📤", 'callback_data' => "goto_mainmenu"]];

            editMessageText([
                'chat_id' => $chat_id,
                'message_id' => $message_id,
                'text' => $searchText,
                'reply_markup' => json_encode($searchKeys)
            ]);

            die();
        }

        die();
    }

    if (strpos($data, "goto_") === 0) {

        $query_parts = explode('_', $data);
        $page = $query_parts[1];

        answerCallbackQuery([
            "callback_query_id" => $membercall,
        ]);

        if ($page == "tontokens") {
            editMessageText([
                'chat_id' => $chat_id,
                'message_id' => $message_id,
                'text' => "اینجا میتونی قیمت برترین رمزارز ها رو بدست بیاری 🚀",
                'reply_markup' => json_encode($TON_TOKENS)
            ]);
            die();
        }

        if ($page == "memetokens") {
            editMessageText([
                'chat_id' => $chat_id,
                'message_id' => $message_id,
                'text' => "اینجا میتونی قیمت برترین رمزارز ها رو بدست بیاری 🚀",
                'reply_markup' => json_encode($MEME_TOKENS)
            ]);
            die();
        }

        if ($page == "hottokens") {

            $topSearchTokens = topSearch();
            $HOT_TOKENS = $TOP_TOKENS;

            if ($topSearchTokens) {

                $HOT_TOKENS = [
                    'inline_keyboard' => []
                ];

                $rowKey = [];
                foreach ($topSearchTokens as $token => $search) {

                    if (count($rowKey) < 2) {

                        $rowKey[] = ['text' => "💰 قیمت " . $token, 'callback_data' => "price_" . $token . "_" . 1];
                    } else {

                        $HOT_TOKENS['inline_keyboard'][] = $rowKey;
                        $rowKey = [];
                        $rowKey[] = ['text' => "💰 قیمت " . $token, 'callback_data' => "price_" . $token . "_" . 1];
                    }
                }

                $HOT_TOKENS['inline_keyboard'][] = $rowKey;

                $HOT_TOKENS['inline_keyboard'][] = [['text' => "بازگشت 📤", 'callback_data' => "goto_mainmenu"]];
            }

            editMessageText([
                'chat_id' => $chat_id,
                'message_id' => $message_id,
                'text' => "اینجا میتونی قیمت برترین رمزارز ها رو بدست بیاری 🚀",
                'reply_markup' => json_encode($HOT_TOKENS)
            ]);
            die();
        }

        if ($page == "toptokens") {
            editMessageText([
                'chat_id' => $chat_id,
                'message_id' => $message_id,
                'text' => "اینجا میتونی قیمت برترین رمزارز ها رو بدست بیاری 🚀",
                'reply_markup' => json_encode($TOP_TOKENS)
            ]);
            die();
        }

        if ($page == "mainmenu") {
            editMessageText([
                'chat_id' => $chat_id,
                'message_id' => $message_id,
                'text' => "برای گرفتن قیمت، کافیه یکی از این فرمت‌ها رو بفرستی:\n🔹 کلمه قیمت + نماد ارز (بدون فاصله)\n🔹 کلمه قیمت + تعداد + نماد ارز\n\nمثال‌ها:\n• قیمت ۲۵ نات\n• قیمت ۴۰۰ TON\n• قیمت BTC\n• قیمت بیتکوین\n\n✨ همچنین می‌تونی من رو به گروه‌هات اضافه کنی تا همه اعضای گروه همزمان و به‌صورت رایگان ازم استفاده کنن!",
                'reply_markup' => json_encode($MAIN_MENU)
            ]);
            die();
        }

        if ($page == "goldprices") {
            $data = getGoldPrice();
            $searchText = "";

            foreach ($data as $item) {
                $searchText .= "🟡 " . $item['name'] . "\n";
                $searchText .= "💰 " . beautifyPrice($item['price']) . " " . $item['unit'] .  "\n";
                $searchText .= "🕰 آپدیت " . $item['date'] . " - " . $item['time'] . "\n\n";
            }

            editMessageText([
                'chat_id' => $chat_id,
                'message_id' => $message_id,
                'text' => $searchText,
                'reply_markup' => json_encode($BACK_MENU)
            ]);
            die();
        }

        if ($page == "helppage") {

            $searchText = "*🤖 راهنمای دستورات ربات*\n\nدر زیر لیست دستورات مجاز جهت استفاده در گروه‌ها و خارج از گروه ارائه شده است\. *توجه:* در گروه‌ها، استفاده از کلمه _'قیمت'_ الزامی می‌باشد؛ در غیر این صورت ربات به پیام شما پاسخ نخواهد داد\. 🚫\n\n*📢 دستورات مجاز در گروه‌ها:*\n- ✅ _قیمت تون_\n- ✅ _قیمت پالیگان_\n- ✅ _قیمت۳۰تون_\n- ✅ _قیمت30تون_\n- ✅ _قیمت ۳۰ بیت کوین_\n- ✅ _قیمت 30 بیت کوین_\n- ✅ _قیمت طلا_\n- ✅ _قیمت سکه_\n\n*🔓 دستورات مجاز خارج از گروه:*\n1\. نام رمزارز\n2\. کلمه _'قیمت'_ + نام رمزارز\n3\. تعداد + نام رمزارز\n4\. کلمه _'قیمت'_ + تعداد + نام رمزارز\n\nنمونه‌هایی از دستورات خارج از گروه:\n- 💡 _بیت کوین_\n- 💡 _قیمت بیت کوین_\n- 💡 _۴۴ بیت کوین_\n- 💡 _۴۴۴ بیت کوین_\n- 💡 _قیمت ۹۸ بیت کوین_\n- 💡 _قیمت طلا_\n- 💡 _قیمت سکه_\n- 💡 _طلا_\n- 💡 _سکه_\n\n*توجه ویژه:* اگر از نماد رمزارز مثل `BTC` یا `TON` استفاده کنید، بسیار بهتر است و احتمال دریافت پاسخ از ربات افزایش می‌یابد\.";

            editMessageText([
                'chat_id' => $chat_id,
                'message_id' => $message_id,
                'text' => $searchText,
                'parse_mode' => 'Markdown',
                'reply_markup' => json_encode($BACK_MENU)
            ]);

            die();
        }

        die();
    }
}

if (isset($text) && !empty($text)) {

    if (strpos($text, "/start") === 0 && isset($tc) && $tc == "private") {

        addUserRequest($chat_id);

        sendMessage([
            'chat_id' => $chat_id,
            'text' => "👋 سلام، خوش اومدی! 🤩\nاینجا می‌تونی قیمت ارزهای دیجیتال رو به‌صورت لحظه‌ای از معتبرترین صرافی‌ها و به شکل کاملاً رایگان دریافت کنی!\n\nبرای گرفتن قیمت، کافیه یکی از این فرمت‌ها رو بفرستی:\n🔹 کلمه قیمت + نماد ارز (بدون فاصله)\n🔹 کلمه قیمت + تعداد + نماد ارز\n\nمثال‌ها:\n• قیمت ۲۵ نات\n• قیمت ۴۰۰ TON\n• قیمت BTC\n• قیمت بیتکوین\n\n✨ همچنین می‌تونی من رو به گروه‌هات اضافه کنی تا همه اعضای گروه همزمان و به‌صورت رایگان ازم استفاده کنن!",
            'reply_markup' => json_encode($MAIN_MENU)

        ]);

        die();
    }

    if (strpos($text, "قیمت") === 0 || $tc == "private") {

        $text = replace_persian_digits($text);

        $text = preg_replace(
            [
                '/(?<=\p{L})(?=\p{N})/u',  // وقتی حرف قبل و عدد بعد وجود دارد
                '/(?<=\p{N})(?=\p{L})/u'   // وقتی عدد قبل و حرف بعد وجود دارد
            ],
            ' ', // جداکننده (فاصله) که به جای مرز قرار می‌گیرد
            $text
        );

        $query_parts = explode(' ', $text);

        $index = 0;
        foreach ($query_parts as $part) {
            if (in_array($part, array_keys($PERSIAN_NUMBER))) {
                $query_parts[$index] = $PERSIAN_NUMBER[$part];
            }
            $index++;
        }

        if ($query_parts[0] === "قیمت") {

            if (count($query_parts) === 3) {

                $count = (float)replace_persian_digits($query_parts[1]);
                $token = $query_parts[2];

                if (!$count) {
                    $count = 1;
                    $token = $query_parts[1] . " " . $query_parts[2];
                }
            } else if (count($query_parts) === 2) {
                $count = 1;
                $token = $query_parts[1];
            } else if (count($query_parts) === 4) {

                $count = (float)replace_persian_digits($query_parts[1]);
                $token = $query_parts[2] . " " . $query_parts[3];
            } else {
                die();
            }
        } else if ($tc == "private") {

            if (count($query_parts) === 1) {
                $count = 1;
                $token = $query_parts[0];
            } else if (count($query_parts) === 2) {
                $count = (float)replace_persian_digits($query_parts[0]);
                $token = $query_parts[1];
            } else if (count($query_parts) === 3) {
                $count = (float)replace_persian_digits($query_parts[0]);
                $token = $query_parts[1] . " " . $query_parts[2];
            } else {

                die();
            }
        }

        if (!$count || $count > 9999999999) {
            die();
        }

        if (strtoupper($token) == "USDT" || $token == "تتر" || $token == "دلار") {

            $searchText = "";
            $searchKeys = [
                'inline_keyboard' => []
            ];

            //////// NOBITEX CHECK

            $nobitextSymbol = strtolower("usdt") . "-rls";
            $nobitexData = getPriceFromNobitex($nobitextSymbol, $count);

            if ($nobitexData) {

                $lastPrice = $nobitexData['last_price'];
                $totalPrice = $nobitexData['total_price'];

                $searchText .= "🟡 قیمت در صرافی نوبیتکس:\n💸 ";
                if ($count != 1) {
                    $searchText .=  $count . " تتر" . " = " . $totalPrice . " تومان\n💸 ";
                }
                $searchText .= 1 . " تتر" . " = " .  $lastPrice . " تومان\n";

                $searchKeys['inline_keyboard'][] = [
                    ['text' => "آموزش نوبیتکس 📝", 'url' => "https://www.youtube.com/watch?v=ro-WsxeesG8"],
                    ['text' => "ورود به نوبیتکس 💫", 'url' => "https://nobitex.ir/signup/?refcode=9270142"],
                ];
            }

            ////////

            //////// BIT PIN CHECK

            $bitpinSymbol = "USDT" . "_IRT";
            $bitpinData = getPriceFromBitpin($bitpinSymbol, $count);

            if ($bitpinData) {

                $lastPrice = $bitpinData['last_price'];
                $totalPrice = $bitpinData['total_price'];

                $searchText .= "🟰🟰🟰🟰🟰\n🟡 " . "قیمت در صرافی بیت پین:\n💸 ";
                if ($count != 1) {
                    $searchText .=  $count . " تتر" . " = " . $totalPrice . " تومان\n💸 ";
                }
                $searchText .= 1 . " تتر" . " = " .  $lastPrice . " تومان";

                $searchKeys['inline_keyboard'][] = [
                    ['text' => "ورود به صرافی بیت پین 💰", 'url' => "https://bitpin.ir/signup/?ref=3XmFr0nB"],
                ];
            }

            ////////

            $status = sendMessage([
                'chat_id' => $chat_id,
                'text' => $searchText,
                'reply_to_message_id' => $message_id,
                'reply_markup' => json_encode($searchKeys)
            ]);

            if ($status) {
                saveBotMessage($chat_id, $status);
                saveBotMessage($chat_id, $message_id);
            }

            die();
        }

        if (in_array("طلا", $query_parts) || in_array("طلا", $query_parts) || $token == "طلا" || $token == "سکه") {

            $data = getGoldPrice();
            $searchText = "";

            foreach ($data as $item) {
                $searchText .= "🟡 " . $item['name'] . "\n";
                $searchText .= "💰 " . beautifyPrice($item['price']) . " " . $item['unit'] .  "\n";
                $searchText .= "🕰 آپدیت " . $item['date'] . " - " . $item['time'] . "\n\n";
            }

            $status = sendMessage([
                'chat_id' => $chat_id,
                'text' => $searchText,
                'reply_to_message_id' => $message_id,
                'reply_markup' => json_encode($BACK_MENU)
            ]);

            if ($status) {
                saveBotMessage($chat_id, $status);
                saveBotMessage($chat_id, $message_id);
            }

            die();
        }

        if (strtolower($token) == "px" || $token == "پیکسل") {

            $apiUrl = "https://api.ston.fi/v1/swap/simulate";

            // پارامترهای مورد نیاز برای درخواست API
            $params = [
                "offer_address" => "EQB420yQsZobGcy0VYDfSKHpG2QQlw-j1f_tPu1J488I__PX",  // آدرس توکن فروش
                "ask_address" => "EQCxE6mUtQJKFnGfaROTKOt1lZbDiiX1kCixRv7Nw2Id_sDs",    // آدرس توکن خرید
                "units" => "10000000000",  // مقدار توکن برای فروش (کوچک‌ترین واحد)
                "slippage_tolerance" => "0.001"  // تحمل لغزش 0.1٪
            ];

            // تبدیل آرایه پارامترها به query string
            $queryString = http_build_query($params);
            $fullUrl = $apiUrl . "?" . $queryString;

            // ارسال درخواست با cURL
            $ch = curl_init();

            curl_setopt($ch, CURLOPT_URL, $fullUrl);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_POST, true);  // متد POST
            curl_setopt($ch, CURLOPT_HTTPHEADER, [
                'Content-Type: application/json'
            ]);

            $response = curl_exec($ch);

            if (curl_errno($ch)) {
                echo "cURL Error: " . curl_error($ch);
                curl_close($ch);
                return;
            }

            curl_close($ch);

            // تبدیل پاسخ JSON به آرایه PHP
            $data = json_decode($response, true);

            if (isset($data['swap_rate'])) {

                $formattedUsdtPrice = number_format($data['swap_rate'] * $count, 3, '.', ',');

                $status = sendMessage([
                    'chat_id' => $chat_id,
                    'text' => "⚡️ طبق آخرین آپدیت صرافی استون :\n\n💸 " . $count . " " . strtoupper($token) . " = " . "$" . $formattedUsdtPrice . "\n💸 " . 1 . " " . strtoupper($token) . " = " . number_format($data['swap_rate'], 3, '.', ',') . "$",
                    'reply_to_message_id' => $message_id,
                ]);
                if ($status) {
                    saveBotMessage($chat_id, $status);
                    saveBotMessage($chat_id, $message_id);
                }
                die();
            } else {
                die();
            }
        }

        $searchToken = searchWithSuggestions($token, $count);

        if (isset($searchToken['ok']) && $searchToken['ok']) {

            addSearch($token);

            $searchText = "";
            $searchKeys = [
                'inline_keyboard' => []
            ];

            foreach ($searchToken['exchanges'] as $exchange => $data) {
                if ($data) {
                    $searchText .= "⚡️ طبق آخرین آپدیت صرافی {$exchange} :\n💸 ";

                    if ($count != 1) {
                        $searchText .=  $count . " " . $searchToken['symbol'] . " = " . $data['total_price'] . " " . $data['currency'] . "\n💸 ";
                    }

                    $searchText .= 1 . " " . $searchToken['symbol'] . " = " .  $data['last_price'] . " " . $data['currency'] . "\n\n";

                    if (isset($data['urls']) && $data['urls']) {
                        $keys = [];
                        foreach ($data['urls'] as $title => $url) {
                            $keys[] =  ['text' => $title, 'url' => $url];
                        }
                        $searchKeys['inline_keyboard'][] = $keys;
                    }
                }
            }

            $searchKeys['inline_keyboard'][] =  [['text' => "بازگشت 📤", 'callback_data' => "goto_mainmenu"]];

            $status = sendMessage([
                'chat_id' => $chat_id,
                'text' => $searchText,
                'reply_to_message_id' => $message_id,
                'reply_markup' => json_encode($searchKeys)
            ]);
            die();
        }

        $keys = [
            'inline_keyboard' => []
        ];

        $rowKey = [];
        foreach ($searchToken['suggestions'] as $suggestion) {
            if (count($rowKey) < 2) {
                $rowKey[] = ['text' => "💰 قیمت " . $suggestion, 'callback_data' => "price_" . $suggestion . "_" . $count];
            } else {
                $keys['inline_keyboard'][] = $rowKey;
                $rowKey = [];
                $rowKey[] = ['text' => "💰 قیمت " . $suggestion, 'callback_data' => "price_" . $suggestion . "_" . $count];
            }
        }
        $keys['inline_keyboard'][] = $rowKey;
        $keys['inline_keyboard'][] =  [['text' => "بازگشت 📤", 'callback_data' => "goto_mainmenu"]];


        $status = sendMessage([
            'chat_id' => $chat_id,
            'text' => $searchToken['text'],
            'reply_to_message_id' => $message_id,
            'reply_markup' => json_encode($keys)
        ]);

        // اطلاع دادن سرچ های ناموجود
        $status = sendMessage([
            'chat_id' => $ADMIN,
            'text' => "🚨 یک عدد جستجو ناموفق : " . $text,
        ]);

        die();
    }
}

die();
