<?php
include_once "../config.php";
include_once "../functions.php";
// URL API
$url = "https://api.nobitex.ir/market/stats";

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_TIMEOUT, 30);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
$response = curl_exec($ch);

if (curl_errno($ch)) {
    curl_close($ch);
    
     bot(
        "sendMessage",
        [
            'chat_id' => 5839603234,
            'text' => 'خطا در دریافت قیمت های نوبیتکس: ' . curl_error($ch),
        ]
    );
    
    die();
}

// بستن cURL
curl_close($ch);

// تبدیل پاسخ JSON به آرایه PHP
$data = json_decode($response, true);

date_default_timezone_set("Asia/Tehran"); // تنظیم منطقه زمانی به تهران
$time = date("H:i");

$array = [];
$array["update_time"] = $time;
$array["data"] = $data;

file_put_contents("data.json",json_encode($array));

?>
